#include <iostream>

using namespace std;

int main()
{
    int n,m,u,v,br=0,t1=0;
    cin>>n>>m;
    int a[m],b[m],t[m];
    for(int i=0;i<m;i++)
        cin>>a[i]>>b[i]>>t[i];
    cin>>u>>v;
    for(int i=0;i<m+1;i++)
    {
        if(a[i]!=u)
        {
            u=b[i-1];
            if(t[i-1]!=t1)
            {
                br++;
                t1=t[i-1];
            }
        }
    }
    cout<<br;
    return 0;
}